#include "mbed.h"
#include "mbed_rpc.h"

/**

  *  This example program has been updated to use the RPC    implementation in the new mbed libraries.

  *  This example demonstrates using RPC over serial

 **/
DigitalIn  Switch3(SW3);
DigitalIn  Switch2(SW2);
RpcDigitalOut myled1(LED1, "myled1");
RpcDigitalOut myled2(LED2, "myled2");
RpcDigitalOut myled3(LED3, "myled3");
Serial pc(USBTX, USBRX);
void LEDControl(Arguments *in, Reply *out);
RPCFunction rpcLED(&LEDControl, "LEDControl");
double x, y;

int main()
{

    //The mbed RPC classes are now wrapped to create an RPC enabled version - see RpcClasses.h so don't add to base class
    // receive commands, and send back the responses
    char buf[256], outbuf[256];
    char strings[20];

    int n = sprintf(strings, "/myled%d/write %d", 1, 1);
    strcpy(buf, strings);
    RPC::call(buf, outbuf);
    n = sprintf(strings, "/myled%d/write %d", 2, 1);
    strcpy(buf, strings);
    RPC::call(buf, outbuf);
    n = sprintf(strings, "/myled%d/write %d", 3, 1);
    strcpy(buf, strings);
    RPC::call(buf, outbuf);

    while (1)
    {
        pc.gets(buf, 20);
        //Call the static call method on the RPC class
        char x = buf[6] - '0';
        if(buf[0]=='w')
        {
            n = sprintf(strings, "/LEDControl/run %d", x);
            strcpy(buf, strings);
            RPC::call(buf, outbuf);
            pc.printf("\n");
        }
        else
        {
            int a=Switch2;
            int b=Switch3;
            pc.printf("SW2:%d\tSW3:%d\n",a,b);
        }
        // pc.printf("Hello\n");
    }
}

// Make sure the method takes in Arguments and Reply objects.

void LEDControl(Arguments *in, Reply *out)
{
    bool success = true;
    // In this scenario, when using RPC delimit the two arguments with a space.
    x = in->getArg<double>();
    y = in->getArg<double>();
    // Have code here to call another RPC function to wake up specific led or close it.
    char buffer[200], outbuf[256];
    char strings[20];
    int led = x;
    int n = sprintf(strings, "/myled%d/write %d", led, 0);
    strcpy(buffer, strings);
    RPC::call(buffer, outbuf);
    wait(.5);
    n = sprintf(strings, "/myled%d/write %d", led, 1);
    strcpy(buffer, strings);
    RPC::call(buffer, outbuf);
    if (success)
    {
        //out->putData(buffer);
    }
    else
    {
        out->putData("Failed to execute LED control.");
    }
}